
OpenFileGUI {
	
	var <window, <returnKey, <func1, <func2, <>path, <filePath, <>recursive, <bounds, <allPaths, <listView, <drag, <name, <>backColor, <>closeOnAction, <pathPost, <>listItem, <>nameInclude, <>isSnd, <>isMono, <>isStereo, <>isMP3, >msOverSlct = false, >msOverY;
	
	*new {|name = "", path = "~", recursive = false, bounds, backColor, closeOnAction, listItem, nameInclude = "*", isSnd = 0, isMono = 0, isStereo = 0, isMP3 = 0|
		^super.new.initOpenFileGUI(name, path, recursive, bounds, backColor, closeOnAction, listItem, nameInclude, isSnd, isMono, isStereo, isMP3);
	}
	
	initOpenFileGUI {|argName, argPath, argRecursive, argBounds, argBackColor, argCloseOnAction, argListItem, argNameInclude, argIsSnd, argIsMono, argIsStereo, argIsMP3|
		var fnt= Font("Monaco", 10);
		var col= Color.black;
		name= argName;
		path= PathName(argPath).asAbsolutePath;
		recursive = argRecursive;
		bounds= argBounds;
		bounds= bounds ? Rect(1280-160, 41, 159, 769);//default bounds
		window= Window(name, bounds, false).alpha_(0.9).acceptsMouseOver_(true).alwaysOnTop_(true).front;
		backColor = argBackColor;
		window.view.background= backColor;
		closeOnAction = argCloseOnAction;
		listItem = argListItem;
		nameInclude = argNameInclude;
		isSnd = argIsSnd;
		isMono = argIsMono;
		isStereo = argIsStereo;
		isMP3 = argIsMP3;
		Button(window, Rect(1, 1, bounds.width-2/4, 17))
			.states_([["Update", col, Color.clear]])
			.canFocus_(false)
			.action_{this.update};
		drag = DragSink(window, Rect(bounds.width-2/4+1, 1, bounds.width-2/2, 17));
		drag.string_("Drag Folder Here").align_(\center);
		drag.canReceiveDragHandler = {View.currentDrag.isKindOf(Array)};
		drag.receiveDragHandler = {path = View.currentDrag[0]; if (PathName(path).isFile) {listItem = PathName(path).fileName; path = PathName(path).pathOnly; path = path.copyFromStart(path.size - 2)}; this.update; ("osascript -e 'tell application \"Finder\" to close window 1'; osascript -e 'tell application \"LoopToys\" to activate'").unixCmd};
		Button(window, Rect((bounds.width-2/4*3)+1, 1, bounds.width-2/4, 17))
			.states_([["reveal", col, Color.clear]])
			.canFocus_(false)
			.action_{
				Platform.case(
				    \osx, {
						//fails if there is a ' in the filename
						var p = allPaths[listView.value];
						if ((p != nil),
						    {("osascript -e 'tell application \"Finder\" to (reveal item \""
						       ++p.copyToEnd(p.copyRange(0, 1).findAll("/").maxItem).tr($/, $:)++"\" of startup disk) activate'").unixCmd},
						    {("open" + path).unixCmd})
					      },
					     {"OpenFileGUI: reveal for osx only".postln}
				);
			};
		if (recursive != nil)
			{Button(window, Rect((bounds.width-2/4*3)+1, 18, bounds.width-2/4, 17))
			.states_([["recurs.", col, Color.clear], ["recurs.", col, Color.green.alpha_(0.8)]])
			.canFocus_(false)
			.action_{|val| recursive = [false, true][val.value]; this.update}
			.value_(recursive.binaryValue)};
		pathPost = StaticText(window, Rect(0, 18, [bounds.width, bounds.width - 2 / 4 * 3][binaryValue(recursive != nil)], 17)).align_(\center)
		.font_(fnt);
		listView = ListView(window, Rect(0, 40, bounds.width, bounds.height-41))
		.font_(fnt)
		.focus
		.background_(backColor);
		
		msOverY = bounds.height / 2;
		listView.enterKeyAction_{|view|
							  if(allPaths.notEmpty) {filePath = allPaths[view.value]};
							  if(closeOnAction == 1) {window.close};
							  func1.value}
			    .keyDownAction_{|view, char, mod, unicode, keycode|
          	    				  case{keycode == 50} {msOverSlct = true} //"<"(fr)
          	    				      {unicode == 3} {returnKey = 0; window.close}
          	    				      {unicode == 13} {returnKey = 1}
          	    				      {keycode == 51} {if(allPaths.notEmpty) {filePath = allPaths[view.value]};
											    func2.value}; //"del" key
          	    				  view.defaultKeyDownAction(char, mod, unicode)}
          	    .keyUpAction_{|view, char, mod, unicode, keycode|
          	    			    case{keycode == 50} {msOverSlct = false}} 
          	    .mouseOverAction_{arg view, x, y;
          	                      if (msOverSlct) {if (y < msOverY, {listView.value_((listView.value - (0.2 * (bounds.height/18))).max(0))},
          	                                                        {listView.value_((listView.value + (0.2 * (bounds.height/18))).min(listView.items.size - 1))})};
          	                      msOverY = y};                       

		this.update;
		
	} 
	
	update {
		var f = SoundFile.new, func;
		allPaths= List.new;
		if(recursive ? false, {
			func= {|x|
				x.do{|y|
					if(PathName(y).isFolder, {
						func.value((y ++ nameInclude).pathMatch);
					}, {
						f.openRead(y);
						if ((isSnd == 0) || ((isSnd == 1) && (((PathName(y).fullPath.isSoundFile) && (((isMono == 0) && (isStereo == 0)) || ((isMono == 1) && (f.numChannels == 1)) || ((isStereo == 1) && (f.numChannels == 2)))) || ((isMP3 == 1) && (PathName(y).extension == "mp3"))))) {allPaths.add(y)};
				 });	
			   };
			};
			func.value((path ++ "/" ++ nameInclude).pathMatch);
		}, {
			(path ++ "/" ++ nameInclude).pathMatch.do{|y|
				
				if(PathName(y).isFile, {
					f.openRead(y);
					if ((isSnd == 0) || ((isSnd == 1) && (((PathName(y).fullPath.isSoundFile) && (((isMono == 0) && (isStereo == 0)) || ((isMono == 1) && (f.numChannels == 1)) || ((isStereo == 1) && (f.numChannels == 2)))) || ((isMP3 == 1) && (PathName(y).extension == "mp3"))))) {allPaths.add(y)};
				});
			};
		});
		f.close;
		defer{var nChar = ((15 * bounds.width + [- 2, bounds.width-2/4][binaryValue(recursive == nil)]) / 4 * (3 / 100)).round, foundItem;
	           listView.items= allPaths.asArray.collect{|x| x.asString.basename};
		      if (path.size < (nChar + 2), {
		      		pathPost.string_(path);
		      				    }, {
		              pathPost.string_(path.copyFromStart((nChar/2).round.asInteger) ++ ".." ++ path.copyToEnd((path.size) - (nChar/2 - 1).round.asInteger));
		                           });
		      foundItem = listView.items.find([listItem]);
		      if ((listItem != nil) && (foundItem != nil)) {listView.value = foundItem};
		      listItem = nil};
	}
	
	font_ {|font|
		window.view.children.do{|view| view.font= font};
		window.refresh;
	}
	
	front {
		window.front;
	}
		
	name_ {|argName|
		name = argName;
		window.name = argName;
	}
	
	action_ {|func|
		func1= func
	}
	
	delKeyAction_ {|func|
		func2 = func
	}
		
	close {window.close
	}
}

